searchNodes=[{"doc":"Workflow engine. A basic understanding of graph theory would elucidate an intuitive grasp of this package.","ref":"Fountainedge.html","title":"Fountainedge","type":"module"},{"doc":"Returns a list of out edge nodes that are valid transitions. Same as out_edges/1, but with the nodes also for convenience.","ref":"Fountainedge.html#out_edge_nodes/1","title":"Fountainedge.out_edge_nodes/1","type":"function"},{"doc":"Returns a list of out edges that are valid transitions. The out edge is an edge leading out of a current node. Then pass the chosen edge into Fountainedge.transition/2 .","ref":"Fountainedge.html#out_edges/1","title":"Fountainedge.out_edges/1","type":"function"},{"doc":"Transition between nodes along an edge. The current nodes are tracked as a state, and parallel processess are tracked using tokens. A valid out edge must be given.","ref":"Fountainedge.html#transition/2","title":"Fountainedge.transition/2","type":"function"},{"doc":"A graph edge directionally links two nodes together. Edges are fundamental to the concept of transitioning between nodes. Graphviz is used for presentation and ranking of graph nodes. See Graphvix.Graph.add_edge/4 .","ref":"Fountainedge.Edge.html","title":"Fountainedge.Edge","type":"module"},{"doc":"Find a matching edge in a list (used internally.)","ref":"Fountainedge.Edge.html#find/2","title":"Fountainedge.Edge.find/2","type":"function"},{"doc":"Graphing functions.","ref":"Fountainedge.Graph.html","title":"Fountainedge.Graph","type":"module"},{"doc":"Graphs a schema as a UML Activity Diagram using Graphviz . If given a workflow, the graph will be decorationed with stateful information such as the current node (or nodes.)","ref":"Fountainedge.Graph.html#graph/1","title":"Fountainedge.Graph.graph/1","type":"function"},{"doc":"Ranks all nodes in a given schema. Will set the rank field on each Fountainedge.Node within the schema. Useful for determining backward and forward directions between two nodes. If the rank of the out edge node is less than the current node, then the direction is backwards. Otherwise, if greater, then the direction is forwards. dot creates hierarchical or layered drawings of directed graphs. A ranking algorithmn is used to determine this heirarchy. It may be useful to use these ranks when determining direction in a workflow. Call this function to calculate ranks per each node.","ref":"Fountainedge.Graph.html#rank/2","title":"Fountainedge.Graph.rank/2","type":"function"},{"doc":"A graph node (also known as a vertex.) Graphviz is used for presentation and ranking of graph nodes. See Graphvix.Graph.add_vertex/3 .","ref":"Fountainedge.Node.html","title":"Fountainedge.Node","type":"module"},{"doc":"Find a matching node in a list (used internally.)","ref":"Fountainedge.Node.html#find/2","title":"Fountainedge.Node.find/2","type":"function"},{"doc":"The schema models the underlying stateless structure of a workflow as a graph consisting of nodes and edges.","ref":"Fountainedge.Schema.html","title":"Fountainedge.Schema","type":"module"},{"doc":"Tracks the current stateful progression of the workflow.","ref":"Fountainedge.State.html","title":"Fountainedge.State","type":"module"},{"doc":"Tokens track parallel progression from a fork to a join.","ref":"Fountainedge.Token.html","title":"Fountainedge.Token","type":"module"},{"doc":"Models a workflow (stateful.) The workflow is based on a Fountainedge.Schema Current nodes of the flowchart are tracked a list of Fountainedge.State .","ref":"Fountainedge.Workflow.html","title":"Fountainedge.Workflow","type":"module"},{"doc":"Initialises a workflow. Will set the current state to the initial node specified in the schema.","ref":"Fountainedge.Workflow.html#initialize/1","title":"Fountainedge.Workflow.initialize/1","type":"function"},{"doc":"NOTICE: VERSION 0.1 to VERSION 1.0 UPGRADE HAS BREAKING API CHANGES Fountainedge is a simple workflow engine written in Elixir that roughly models forks and joins as described in the paper Process Modeling Notations and Workflow Patterns by Stephen A. White, IBM Corporation. Uses Graphviz for graphical representations as UML Activity Diagrams. Hex Package Documentation The workflow is modelled as graphs consisting of nodes and edges. Parallel forks and joins are tracked using tokens. This API is currently experimental (version 0.) A stable API will be released under version 1.","ref":"readme.html","title":"Fountainedge","type":"extras"},{"doc":"Define a schema: schema = % Fountainedge.Schema { nodes : [ % Fountainedge.Node { id : 1 , label : &quot;Initial&quot; , type : :initial } , % Fountainedge.Node { id : 2 , label : &quot;Choice 1&quot; } , % Fountainedge.Node { id : 3 , label : &quot;Choice 2&quot; } , % Fountainedge.Node { id : 4 , label : &quot;Before Forking&quot; } , % Fountainedge.Node { id : 5 , type : :fork } , % Fountainedge.Node { id : 6 , label : &quot;Parallel 1.1&quot; } , % Fountainedge.Node { id : 7 , label : &quot;Parallel 1.2&quot; } , % Fountainedge.Node { id : 8 , label : &quot;Parallel 2&quot; } , % Fountainedge.Node { id : 9 , type : :join } , % Fountainedge.Node { id : 10 , label : &quot;After Joining&quot; } , % Fountainedge.Node { id : 11 , label : &quot;Final&quot; , type : :final } , ] , edges : [ % Fountainedge.Edge { id : 1 , next : 2 } , % Fountainedge.Edge { id : 1 , next : 3 } , % Fountainedge.Edge { id : 2 , next : 4 } , % Fountainedge.Edge { id : 3 , next : 4 } , % Fountainedge.Edge { id : 4 , next : 5 } , % Fountainedge.Edge { id : 5 , next : 6 } , % Fountainedge.Edge { id : 5 , next : 8 } , % Fountainedge.Edge { id : 6 , next : 7 } , % Fountainedge.Edge { id : 7 , next : 6 } , % Fountainedge.Edge { id : 7 , next : 9 } , % Fountainedge.Edge { id : 8 , next : 9 } , % Fountainedge.Edge { id : 9 , next : 10 } , % Fountainedge.Edge { id : 10 , next : 11 } , ] , } Initialise the workflow: workflow = Fountainedge.Workflow . initialize ( schema ) Get a list of valid out edges: Fountainedge . out_edges ( workflow ) # [%Fountainedge.Edge{id: 1, next: 2}] Transition along an out edge: workflow = Fountainedge . transition ( workflow , % Fountainedge.Edge { id : 1 , next : 2 } ) Graphing: Fountainedge.Graph . graph ( workflow ) |&gt; Graphvix.Graph . compile ( filename , :svg )","ref":"readme.html#example","title":"Fountainedge - Example","type":"extras"},{"doc":"This package can be installed by adding fountainedge to your list of dependencies in mix.exs : def deps do [ { :fountainedge , &quot;~&gt; 1.0.0&quot; } ] end","ref":"readme.html#installation","title":"Fountainedge - Installation","type":"extras"},{"doc":"","ref":"example1.html","title":"Example: Simple","type":"extras"}]